/* Version 1.0 (Beta Test)
 * Copyright (c) Rui Zhang, 2007
 *
 * Permission is hereby given for the use of the code subject to the
 *  following conditions:
 *  - The code will not be sold for profit without explicit written
 *    permission from Rui Zhang.
 *  - This copyright notice and author information will not be altered
 *  - All bug fixes will be returned to rui@csse.unimelb.edu.au for
 *    inclusion in future releases
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#define D 16

#define compactrate 0.9f //should be set larger than 0.75 and smaller than 1.0; when set as -1.0, no compaction

#ifndef PAGE_SIZE
#define PAGE_SIZE 4096
#endif

#define O_PAGE_SIZE 4096

#ifndef MAX_STACK
#define MAX_STACK 300
#endif

#define BUF_SIZE 1

#define NULL_VALUE -1

#define TRUE 1

#define FALSE 0

typedef float KEYTYPE;
typedef long PTR;

typedef float DATA_TYPE;

typedef struct {
   DATA_TYPE fields[D];
} RECORD_TYPE;

typedef struct {
   float start[D];   
   float end[D];   
} range;


#define I_FAN_OUT ((int)(PAGE_SIZE-(2*(sizeof(int)))+(sizeof(KEYTYPE)))/((sizeof(KEYTYPE))+(sizeof(PTR))))

typedef struct{
  int Level;
  int NumKey;
  KEYTYPE Keys[I_FAN_OUT-1];
  PTR     Children[I_FAN_OUT];
} INODE;

typedef struct _IMINODE{
  int Level;
  int NumKey;
  KEYTYPE Keys[I_FAN_OUT-1];
  struct _IMINODE *Children[I_FAN_OUT];
} IMINODE;

typedef struct{
  KEYTYPE Key;
  float ver[D];
  long Offset; 
} LENTRY;

#define L_FAN_OUT (((int)(PAGE_SIZE-(sizeof(int))*2-(sizeof(long))*3)/(sizeof(LENTRY))))

typedef struct{
  int NumEntry;
  PTR Next;  
  PTR Prev;
  LENTRY Entries[L_FAN_OUT];
  PTR Overflow;
  int overflowNum;
} LNODE;

#define O_FAN_OUT (((int)(O_PAGE_SIZE-(sizeof(int))-(sizeof(long)))/(sizeof(LENTRY))))

typedef struct{
  int NumEntry;
  PTR Next;
  LENTRY Entries[O_FAN_OUT];
} ONODE;

typedef struct{
  FILE* BTreeFile;  /* the file where the b+ tree is stored */
  FILE* SrhResult;  /* the file to store searching result form the btree */
  PTR   Root;       /* the offset of root node in the file  */
  PTR   Leaf_Head;  /* the offset of the first leaf node, from which 
                     * a sequencial scan can be started */
  PTR   Stacks[MAX_STACK];
  int   top;
} BTREE;

typedef struct{
  FILE* Fp;
  long  Offset;
}BUFFER_ENTRY;

typedef struct _OFFSETLIST{
  long Offset;
  struct _OFFSETLIST *next;
}OFFSETLIST;

DATA_TYPE idistance(RECORD_TYPE record,float cluster[][D]);

DATA_TYPE Dis_Value(RECORD_TYPE record);
